/*
** 冒泡排序算法的C++实现
** 假设：对N个数字进行升序排序
*/
void bubbleSort(vector<int>& seq)
{
    int index = 0;    //设置边界值，下一次比较到此处即停止
    int length = seq.size();  //待排序序列的长度
    bool flag = true;   //设置标志位，标志为true则继续进行排序，标志为false则序列已经排好序，终止排序
    for (int i = 0; i < length && flag; i = index) {
        flag = false;
        for (int j = length - 2; j >= i; j--) {
            if (seq[j] > seq[j + 1]) { //前一个元素比后一个元素大，交换这两个元素
                index = j;    //若存在数据交换，设置边界值为j
                seq[j] ^= seq[j + 1];
                seq[j + 1] ^= seq[j];
                seq[j] ^= seq[j + 1];
                flag = true; //若存在数据交换，则序列没有排好序，设置标志为true
            }
        }
    }
}