/*
** 基数排序的C++实现
** 假设：对N个整数进行升序排序
** 循环的将相同位的数字分配到同一个的链表中
** 当最高位比较完成时，全部的数据会被分配到P[0]中
*/
void radixSort(vector<int>& seq){
    list<int> p[10];  // 用于存储每次分配数字的链表
    int k = 1, nums = 0;

    while (nums != seq.size()){ // 当记录没有全部存储到P[0]时
        for (int h = 0; h < seq.size(); h++){ // 开始按位分配数字
            int m = (seq[h] / k) % 10;
            p[m].push_back(seq[h]);  // 将数字压入其对应的链表中
        }
        seq.clear();
        nums = int(p[0].size()); // nums设置为P[0]的大小
        for (int i = 0; i < 10; i++){
            while (p[i].size()){ // 将刚刚分配的数字按顺序收集起来
                seq.push_back(p[i].front());
                p[i].pop_front();
            }
        }
        k = k * 10;
    }
}