/*
** 希尔排序的C++实现
** 假设：对N个数字进行升序排序
*/
void shellSort(vector<int>& seq){
    int i,j,temp,increment = seq.size(); 
    do{ 
        increment = increment / 3 + 1; // 缩小增量
        for (i = increment; i < seq.size(); i++){
            if (seq[i] < seq[i - increment]){
                temp = seq[i];
                for (j = i - increment; j >=0  && temp < seq[j]; j -= increment) // 寻找插入位置
                    seq[j + increment] = seq[j];
                seq[j + increment] = temp; // 将数字插入到正确的位置
            }
        }
    }while (increment > 1);
}