/*
** 直接选择排序算法的C++实现
** 假设：对N个数字进行升序排序
*/
void selectSort(vector<int>& seq){
    int length = seq.size();	// 待排序序列的长度
    for(int i=0;i<length-1;i++){
        int min=i,j=i+1;	// min设置为当前最小元素的下标
        for(;j<length;j++)	// 从未排好序的序列中选择最小的元素
            if(seq[j]<=seq[min]) min=j;	

        if(min!=i){	  // 设置min!=i防止元素自身与自身交换
        	seq[i] ^= seq[min];
        	seq[min] ^= seq[i];
        	seq[i] ^= seq[min];
        }
    }
}