/*
** 计数序算法的C++实现
** 假设：对N个数字进行升序排序
** 利用STL-HashMap的属性：
**  1.当键不存在时，则新增，初始值默认为0
**  2.当键不存在时，if条件判断的结果为false
*/
void countingSort(vector<int>& seq){
    map<int,int> record;    // 定义桶
    int min = seq[0],max=seq[0]; 
    for(int k=1;k<seq.size();k++) { //找到最大值最小值
        if(seq[k]<min) min=seq[k];
        if(seq[k]>max) max=seq[k];
    }
    for(int i=0;i<seq.size();i++) record[seq[i]]++; // 将数字放入对应的桶中
    seq.clear();
    for(int j=min;j<=max;j++) if(record[j]) seq.insert(seq.end(),record[j],j); // 将桶中的数字重新插入到数组中
}